import { ATN } from "antlr4ts/atn/ATN";
import { Parser } from "antlr4ts/Parser";
import { ParserRuleContext } from "antlr4ts/ParserRuleContext";
import { TerminalNode } from "antlr4ts/tree/TerminalNode";
import { TokenStream } from "antlr4ts/TokenStream";
import { Vocabulary } from "antlr4ts/Vocabulary";
import { ExpressionListener } from "./ExpressionListener";
import { ExpressionVisitor } from "./ExpressionVisitor";
export declare class ExpressionParser extends Parser {
    static readonly T__0 = 1;
    static readonly WS = 2;
    static readonly TRUE = 3;
    static readonly FALSE = 4;
    static readonly AND = 5;
    static readonly OR = 6;
    static readonly XOR = 7;
    static readonly IN = 8;
    static readonly IS = 9;
    static readonly BETWEEN = 10;
    static readonly LIKE = 11;
    static readonly MATCHES = 12;
    static readonly NULL_LITERAL = 13;
    static readonly DOT = 14;
    static readonly AT = 15;
    static readonly BACKTICK = 16;
    static readonly BACKSLASH = 17;
    static readonly PIPE = 18;
    static readonly BANG = 19;
    static readonly QMARK = 20;
    static readonly DOLLAR = 21;
    static readonly POUND = 22;
    static readonly LPAREN = 23;
    static readonly RPAREN = 24;
    static readonly LBRACKET = 25;
    static readonly RBRACKET = 26;
    static readonly LCURLY = 27;
    static readonly RCURLY = 28;
    static readonly COMMA = 29;
    static readonly SEMI = 30;
    static readonly COLON = 31;
    static readonly ASSIGN = 32;
    static readonly DEFAULT = 33;
    static readonly PLUS = 34;
    static readonly MINUS = 35;
    static readonly DIV = 36;
    static readonly STAR = 37;
    static readonly MOD = 38;
    static readonly POWER = 39;
    static readonly EQUAL = 40;
    static readonly NOT_EQUAL = 41;
    static readonly LESS_THAN = 42;
    static readonly LESS_THAN_OR_EQUAL = 43;
    static readonly GREATER_THAN = 44;
    static readonly GREATER_THAN_OR_EQUAL = 45;
    static readonly PROJECT = 46;
    static readonly SELECT = 47;
    static readonly SELECT_FIRST = 48;
    static readonly SELECT_LAST = 49;
    static readonly TYPE = 50;
    static readonly LAMBDA = 51;
    static readonly DOT_ESCAPED = 52;
    static readonly QUOTE = 53;
    static readonly STRING_LITERAL = 54;
    static readonly APOS = 55;
    static readonly ID = 56;
    static readonly REAL_LITERAL = 57;
    static readonly INTEGER_LITERAL = 58;
    static readonly HEXADECIMAL_INTEGER_LITERAL = 59;
    static readonly DECIMAL_DIGIT = 60;
    static readonly INTEGER_TYPE_SUFFIX = 61;
    static readonly HEX_DIGIT = 62;
    static readonly EXPONENT_PART = 63;
    static readonly SIGN = 64;
    static readonly REAL_TYPE_SUFFIX = 65;
    static readonly RULE_expr = 0;
    static readonly RULE_exprList = 1;
    static readonly RULE_expression = 2;
    static readonly RULE_parenExpr = 3;
    static readonly RULE_logicalOrExpression = 4;
    static readonly RULE_logicalXorExpression = 5;
    static readonly RULE_logicalAndExpression = 6;
    static readonly RULE_relationalExpression = 7;
    static readonly RULE_sumExpr = 8;
    static readonly RULE_prodExpr = 9;
    static readonly RULE_powExpr = 10;
    static readonly RULE_unaryExpression = 11;
    static readonly RULE_primaryExpression = 12;
    static readonly RULE_startNode = 13;
    static readonly RULE_node = 14;
    static readonly RULE_functionOrVar = 15;
    static readonly RULE_function = 16;
    static readonly RULE_var = 17;
    static readonly RULE_localFunctionOrVar = 18;
    static readonly RULE_localFunction = 19;
    static readonly RULE_localVar = 20;
    static readonly RULE_methodOrProperty = 21;
    static readonly RULE_method = 22;
    static readonly RULE_methodArgs = 23;
    static readonly RULE_property = 24;
    static readonly RULE_reference = 25;
    static readonly RULE_indexer = 26;
    static readonly RULE_projection = 27;
    static readonly RULE_selection = 28;
    static readonly RULE_firstSelection = 29;
    static readonly RULE_lastSelection = 30;
    static readonly RULE_type = 31;
    static readonly RULE_name = 32;
    static readonly RULE_quotableName = 33;
    static readonly RULE_attribute = 34;
    static readonly RULE_lambda = 35;
    static readonly RULE_argList = 36;
    static readonly RULE_ctor = 37;
    static readonly RULE_arrayConstructor = 38;
    static readonly RULE_arrayRank = 39;
    static readonly RULE_listInitializer = 40;
    static readonly RULE_mapInitializer = 41;
    static readonly RULE_mapEntry = 42;
    static readonly RULE_ctorArgs = 43;
    static readonly RULE_argument = 44;
    static readonly RULE_namedArgument = 45;
    static readonly RULE_qualifiedId = 46;
    static readonly RULE_literal = 47;
    static readonly RULE_nullLiteral = 48;
    static readonly RULE_integerLiteral = 49;
    static readonly RULE_hexLiteral = 50;
    static readonly RULE_realLiteral = 51;
    static readonly RULE_stringLiteral = 52;
    static readonly RULE_boolLiteral = 53;
    static readonly RULE_relationalOperator = 54;
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    readonly vocabulary: Vocabulary;
    readonly grammarFileName: string;
    readonly ruleNames: string[];
    readonly serializedATN: string;
    constructor(input: TokenStream);
    expr(): ExprContext;
    exprList(): ExprListContext;
    expression(): ExpressionContext;
    parenExpr(): ParenExprContext;
    logicalOrExpression(): LogicalOrExpressionContext;
    logicalXorExpression(): LogicalXorExpressionContext;
    logicalAndExpression(): LogicalAndExpressionContext;
    relationalExpression(): RelationalExpressionContext;
    sumExpr(): SumExprContext;
    prodExpr(): ProdExprContext;
    powExpr(): PowExprContext;
    unaryExpression(): UnaryExpressionContext;
    primaryExpression(): PrimaryExpressionContext;
    startNode(): StartNodeContext;
    node(): NodeContext;
    functionOrVar(): FunctionOrVarContext;
    function(): FunctionContext;
    var(): VarContext;
    localFunctionOrVar(): LocalFunctionOrVarContext;
    localFunction(): LocalFunctionContext;
    localVar(): LocalVarContext;
    methodOrProperty(): MethodOrPropertyContext;
    method(): MethodContext;
    methodArgs(): MethodArgsContext;
    property(): PropertyContext;
    reference(): ReferenceContext;
    indexer(): IndexerContext;
    projection(): ProjectionContext;
    selection(): SelectionContext;
    firstSelection(): FirstSelectionContext;
    lastSelection(): LastSelectionContext;
    type(): TypeContext;
    name(): NameContext;
    quotableName(): QuotableNameContext;
    attribute(): AttributeContext;
    lambda(): LambdaContext;
    argList(): ArgListContext;
    ctor(): CtorContext;
    arrayConstructor(): ArrayConstructorContext;
    arrayRank(): ArrayRankContext;
    listInitializer(): ListInitializerContext;
    mapInitializer(): MapInitializerContext;
    mapEntry(): MapEntryContext;
    ctorArgs(): CtorArgsContext;
    argument(): ArgumentContext;
    namedArgument(): NamedArgumentContext;
    qualifiedId(): QualifiedIdContext;
    literal(): LiteralContext;
    nullLiteral(): NullLiteralContext;
    integerLiteral(): IntegerLiteralContext;
    hexLiteral(): HexLiteralContext;
    realLiteral(): RealLiteralContext;
    stringLiteral(): StringLiteralContext;
    boolLiteral(): BoolLiteralContext;
    relationalOperator(): RelationalOperatorContext;
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static readonly _ATN: ATN;
}
export declare class ExprContext extends ParserRuleContext {
    expression(): ExpressionContext;
    EOF(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class ExprListContext extends ParserRuleContext {
    LPAREN(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    RPAREN(): TerminalNode;
    SEMI(): TerminalNode[];
    SEMI(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class ExpressionContext extends ParserRuleContext {
    logicalOrExpression(): LogicalOrExpressionContext[];
    logicalOrExpression(i: number): LogicalOrExpressionContext;
    ASSIGN(): TerminalNode | undefined;
    DEFAULT(): TerminalNode | undefined;
    QMARK(): TerminalNode | undefined;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COLON(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class ParenExprContext extends ParserRuleContext {
    LPAREN(): TerminalNode;
    expression(): ExpressionContext;
    RPAREN(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class LogicalOrExpressionContext extends ParserRuleContext {
    logicalXorExpression(): LogicalXorExpressionContext[];
    logicalXorExpression(i: number): LogicalXorExpressionContext;
    OR(): TerminalNode[];
    OR(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class LogicalXorExpressionContext extends ParserRuleContext {
    logicalAndExpression(): LogicalAndExpressionContext[];
    logicalAndExpression(i: number): LogicalAndExpressionContext;
    XOR(): TerminalNode[];
    XOR(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class LogicalAndExpressionContext extends ParserRuleContext {
    relationalExpression(): RelationalExpressionContext[];
    relationalExpression(i: number): RelationalExpressionContext;
    AND(): TerminalNode[];
    AND(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class RelationalExpressionContext extends ParserRuleContext {
    sumExpr(): SumExprContext[];
    sumExpr(i: number): SumExprContext;
    relationalOperator(): RelationalOperatorContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class SumExprContext extends ParserRuleContext {
    prodExpr(): ProdExprContext[];
    prodExpr(i: number): ProdExprContext;
    PLUS(): TerminalNode[];
    PLUS(i: number): TerminalNode;
    MINUS(): TerminalNode[];
    MINUS(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class ProdExprContext extends ParserRuleContext {
    powExpr(): PowExprContext[];
    powExpr(i: number): PowExprContext;
    STAR(): TerminalNode[];
    STAR(i: number): TerminalNode;
    DIV(): TerminalNode[];
    DIV(i: number): TerminalNode;
    MOD(): TerminalNode[];
    MOD(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class PowExprContext extends ParserRuleContext {
    unaryExpression(): UnaryExpressionContext[];
    unaryExpression(i: number): UnaryExpressionContext;
    POWER(): TerminalNode[];
    POWER(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class UnaryExpressionContext extends ParserRuleContext {
    unaryExpression(): UnaryExpressionContext | undefined;
    PLUS(): TerminalNode | undefined;
    MINUS(): TerminalNode | undefined;
    BANG(): TerminalNode | undefined;
    primaryExpression(): PrimaryExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class PrimaryExpressionContext extends ParserRuleContext {
    startNode(): StartNodeContext;
    node(): NodeContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class StartNodeContext extends ParserRuleContext {
    exprList(): ExprListContext | undefined;
    parenExpr(): ParenExprContext | undefined;
    methodOrProperty(): MethodOrPropertyContext | undefined;
    functionOrVar(): FunctionOrVarContext | undefined;
    localFunctionOrVar(): LocalFunctionOrVarContext | undefined;
    reference(): ReferenceContext | undefined;
    literal(): LiteralContext | undefined;
    indexer(): IndexerContext | undefined;
    type(): TypeContext | undefined;
    ctor(): CtorContext | undefined;
    projection(): ProjectionContext | undefined;
    selection(): SelectionContext | undefined;
    firstSelection(): FirstSelectionContext | undefined;
    lastSelection(): LastSelectionContext | undefined;
    listInitializer(): ListInitializerContext | undefined;
    mapInitializer(): MapInitializerContext | undefined;
    lambda(): LambdaContext | undefined;
    attribute(): AttributeContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class NodeContext extends ParserRuleContext {
    methodOrProperty(): MethodOrPropertyContext[];
    methodOrProperty(i: number): MethodOrPropertyContext;
    indexer(): IndexerContext[];
    indexer(i: number): IndexerContext;
    projection(): ProjectionContext[];
    projection(i: number): ProjectionContext;
    selection(): SelectionContext[];
    selection(i: number): SelectionContext;
    firstSelection(): FirstSelectionContext[];
    firstSelection(i: number): FirstSelectionContext;
    lastSelection(): LastSelectionContext[];
    lastSelection(i: number): LastSelectionContext;
    exprList(): ExprListContext[];
    exprList(i: number): ExprListContext;
    DOT(): TerminalNode[];
    DOT(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class FunctionOrVarContext extends ParserRuleContext {
    function(): FunctionContext | undefined;
    var(): VarContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class FunctionContext extends ParserRuleContext {
    POUND(): TerminalNode;
    ID(): TerminalNode;
    methodArgs(): MethodArgsContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class VarContext extends ParserRuleContext {
    POUND(): TerminalNode;
    ID(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class LocalFunctionOrVarContext extends ParserRuleContext {
    localFunction(): LocalFunctionContext | undefined;
    localVar(): LocalVarContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class LocalFunctionContext extends ParserRuleContext {
    DOLLAR(): TerminalNode;
    ID(): TerminalNode;
    methodArgs(): MethodArgsContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class LocalVarContext extends ParserRuleContext {
    DOLLAR(): TerminalNode;
    ID(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class MethodOrPropertyContext extends ParserRuleContext {
    method(): MethodContext | undefined;
    property(): PropertyContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class MethodContext extends ParserRuleContext {
    ID(): TerminalNode;
    methodArgs(): MethodArgsContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class MethodArgsContext extends ParserRuleContext {
    LPAREN(): TerminalNode;
    RPAREN(): TerminalNode;
    argument(): ArgumentContext[];
    argument(i: number): ArgumentContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class PropertyContext extends ParserRuleContext {
    ID(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class ReferenceContext extends ParserRuleContext {
    AT(): TerminalNode | undefined;
    LPAREN(): TerminalNode | undefined;
    quotableName(): QuotableNameContext | undefined;
    COLON(): TerminalNode | undefined;
    RPAREN(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class IndexerContext extends ParserRuleContext {
    LBRACKET(): TerminalNode;
    argument(): ArgumentContext[];
    argument(i: number): ArgumentContext;
    RBRACKET(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class ProjectionContext extends ParserRuleContext {
    PROJECT(): TerminalNode;
    expression(): ExpressionContext;
    RCURLY(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class SelectionContext extends ParserRuleContext {
    SELECT(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    RCURLY(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class FirstSelectionContext extends ParserRuleContext {
    SELECT_FIRST(): TerminalNode;
    expression(): ExpressionContext;
    RCURLY(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class LastSelectionContext extends ParserRuleContext {
    SELECT_LAST(): TerminalNode;
    expression(): ExpressionContext;
    RCURLY(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class TypeContext extends ParserRuleContext {
    TYPE(): TerminalNode;
    name(): NameContext;
    RPAREN(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class NameContext extends ParserRuleContext {
    ID(): TerminalNode;
    RPAREN(): TerminalNode[];
    RPAREN(i: number): TerminalNode;
    COLON(): TerminalNode[];
    COLON(i: number): TerminalNode;
    QUOTE(): TerminalNode[];
    QUOTE(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class QuotableNameContext extends ParserRuleContext {
    STRING_LITERAL(): TerminalNode | undefined;
    name(): NameContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class AttributeContext extends ParserRuleContext {
    AT(): TerminalNode;
    LBRACKET(): TerminalNode;
    qualifiedId(): QualifiedIdContext;
    RBRACKET(): TerminalNode;
    ctorArgs(): CtorArgsContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class LambdaContext extends ParserRuleContext {
    LAMBDA(): TerminalNode;
    PIPE(): TerminalNode;
    expression(): ExpressionContext;
    RCURLY(): TerminalNode;
    argList(): ArgListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class ArgListContext extends ParserRuleContext {
    ID(): TerminalNode[];
    ID(i: number): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class CtorContext extends ParserRuleContext {
    qualifiedId(): QualifiedIdContext | undefined;
    ctorArgs(): CtorArgsContext | undefined;
    arrayConstructor(): ArrayConstructorContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class ArrayConstructorContext extends ParserRuleContext {
    qualifiedId(): QualifiedIdContext;
    arrayRank(): ArrayRankContext;
    listInitializer(): ListInitializerContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class ArrayRankContext extends ParserRuleContext {
    LBRACKET(): TerminalNode;
    RBRACKET(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class ListInitializerContext extends ParserRuleContext {
    LCURLY(): TerminalNode;
    RCURLY(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class MapInitializerContext extends ParserRuleContext {
    POUND(): TerminalNode;
    LCURLY(): TerminalNode;
    RCURLY(): TerminalNode;
    mapEntry(): MapEntryContext[];
    mapEntry(i: number): MapEntryContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class MapEntryContext extends ParserRuleContext {
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COLON(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class CtorArgsContext extends ParserRuleContext {
    LPAREN(): TerminalNode;
    RPAREN(): TerminalNode;
    namedArgument(): NamedArgumentContext[];
    namedArgument(i: number): NamedArgumentContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class ArgumentContext extends ParserRuleContext {
    expression(): ExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class NamedArgumentContext extends ParserRuleContext {
    ID(): TerminalNode | undefined;
    ASSIGN(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    argument(): ArgumentContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class QualifiedIdContext extends ParserRuleContext {
    ID(): TerminalNode[];
    ID(i: number): TerminalNode;
    DOT(): TerminalNode[];
    DOT(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class LiteralContext extends ParserRuleContext {
    nullLiteral(): NullLiteralContext | undefined;
    integerLiteral(): IntegerLiteralContext | undefined;
    hexLiteral(): HexLiteralContext | undefined;
    realLiteral(): RealLiteralContext | undefined;
    stringLiteral(): StringLiteralContext | undefined;
    boolLiteral(): BoolLiteralContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class NullLiteralContext extends ParserRuleContext {
    NULL_LITERAL(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class IntegerLiteralContext extends ParserRuleContext {
    INTEGER_LITERAL(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class HexLiteralContext extends ParserRuleContext {
    HEXADECIMAL_INTEGER_LITERAL(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class RealLiteralContext extends ParserRuleContext {
    REAL_LITERAL(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class StringLiteralContext extends ParserRuleContext {
    STRING_LITERAL(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class BoolLiteralContext extends ParserRuleContext {
    TRUE(): TerminalNode | undefined;
    FALSE(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
export declare class RelationalOperatorContext extends ParserRuleContext {
    EQUAL(): TerminalNode | undefined;
    NOT_EQUAL(): TerminalNode | undefined;
    LESS_THAN(): TerminalNode | undefined;
    LESS_THAN_OR_EQUAL(): TerminalNode | undefined;
    GREATER_THAN(): TerminalNode | undefined;
    GREATER_THAN_OR_EQUAL(): TerminalNode | undefined;
    IN(): TerminalNode | undefined;
    IS(): TerminalNode | undefined;
    BETWEEN(): TerminalNode | undefined;
    LIKE(): TerminalNode | undefined;
    MATCHES(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: ExpressionListener): void;
    exitRule(listener: ExpressionListener): void;
    accept<Result>(visitor: ExpressionVisitor<Result>): Result;
}
