import { ParseTreeListener } from "antlr4ts/tree/ParseTreeListener";
import { ExprContext } from "./ExpressionParser";
import { ExprListContext } from "./ExpressionParser";
import { ExpressionContext } from "./ExpressionParser";
import { ParenExprContext } from "./ExpressionParser";
import { LogicalOrExpressionContext } from "./ExpressionParser";
import { LogicalXorExpressionContext } from "./ExpressionParser";
import { LogicalAndExpressionContext } from "./ExpressionParser";
import { RelationalExpressionContext } from "./ExpressionParser";
import { SumExprContext } from "./ExpressionParser";
import { ProdExprContext } from "./ExpressionParser";
import { PowExprContext } from "./ExpressionParser";
import { UnaryExpressionContext } from "./ExpressionParser";
import { PrimaryExpressionContext } from "./ExpressionParser";
import { StartNodeContext } from "./ExpressionParser";
import { NodeContext } from "./ExpressionParser";
import { FunctionOrVarContext } from "./ExpressionParser";
import { FunctionContext } from "./ExpressionParser";
import { VarContext } from "./ExpressionParser";
import { LocalFunctionOrVarContext } from "./ExpressionParser";
import { LocalFunctionContext } from "./ExpressionParser";
import { LocalVarContext } from "./ExpressionParser";
import { MethodOrPropertyContext } from "./ExpressionParser";
import { MethodContext } from "./ExpressionParser";
import { MethodArgsContext } from "./ExpressionParser";
import { PropertyContext } from "./ExpressionParser";
import { ReferenceContext } from "./ExpressionParser";
import { IndexerContext } from "./ExpressionParser";
import { ProjectionContext } from "./ExpressionParser";
import { SelectionContext } from "./ExpressionParser";
import { FirstSelectionContext } from "./ExpressionParser";
import { LastSelectionContext } from "./ExpressionParser";
import { TypeContext } from "./ExpressionParser";
import { NameContext } from "./ExpressionParser";
import { QuotableNameContext } from "./ExpressionParser";
import { AttributeContext } from "./ExpressionParser";
import { LambdaContext } from "./ExpressionParser";
import { ArgListContext } from "./ExpressionParser";
import { CtorContext } from "./ExpressionParser";
import { ArrayConstructorContext } from "./ExpressionParser";
import { ArrayRankContext } from "./ExpressionParser";
import { ListInitializerContext } from "./ExpressionParser";
import { MapInitializerContext } from "./ExpressionParser";
import { MapEntryContext } from "./ExpressionParser";
import { CtorArgsContext } from "./ExpressionParser";
import { ArgumentContext } from "./ExpressionParser";
import { NamedArgumentContext } from "./ExpressionParser";
import { QualifiedIdContext } from "./ExpressionParser";
import { LiteralContext } from "./ExpressionParser";
import { NullLiteralContext } from "./ExpressionParser";
import { IntegerLiteralContext } from "./ExpressionParser";
import { HexLiteralContext } from "./ExpressionParser";
import { RealLiteralContext } from "./ExpressionParser";
import { StringLiteralContext } from "./ExpressionParser";
import { BoolLiteralContext } from "./ExpressionParser";
import { RelationalOperatorContext } from "./ExpressionParser";
/**
 * This interface defines a complete listener for a parse tree produced by
 * `ExpressionParser`.
 */
export interface ExpressionListener extends ParseTreeListener {
    /**
     * Enter a parse tree produced by `ExpressionParser.expr`.
     * @param ctx the parse tree
     */
    enterExpr?: (ctx: ExprContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.expr`.
     * @param ctx the parse tree
     */
    exitExpr?: (ctx: ExprContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.exprList`.
     * @param ctx the parse tree
     */
    enterExprList?: (ctx: ExprListContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.exprList`.
     * @param ctx the parse tree
     */
    exitExprList?: (ctx: ExprListContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.expression`.
     * @param ctx the parse tree
     */
    enterExpression?: (ctx: ExpressionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.expression`.
     * @param ctx the parse tree
     */
    exitExpression?: (ctx: ExpressionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.parenExpr`.
     * @param ctx the parse tree
     */
    enterParenExpr?: (ctx: ParenExprContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.parenExpr`.
     * @param ctx the parse tree
     */
    exitParenExpr?: (ctx: ParenExprContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.logicalOrExpression`.
     * @param ctx the parse tree
     */
    enterLogicalOrExpression?: (ctx: LogicalOrExpressionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.logicalOrExpression`.
     * @param ctx the parse tree
     */
    exitLogicalOrExpression?: (ctx: LogicalOrExpressionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.logicalXorExpression`.
     * @param ctx the parse tree
     */
    enterLogicalXorExpression?: (ctx: LogicalXorExpressionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.logicalXorExpression`.
     * @param ctx the parse tree
     */
    exitLogicalXorExpression?: (ctx: LogicalXorExpressionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.logicalAndExpression`.
     * @param ctx the parse tree
     */
    enterLogicalAndExpression?: (ctx: LogicalAndExpressionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.logicalAndExpression`.
     * @param ctx the parse tree
     */
    exitLogicalAndExpression?: (ctx: LogicalAndExpressionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.relationalExpression`.
     * @param ctx the parse tree
     */
    enterRelationalExpression?: (ctx: RelationalExpressionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.relationalExpression`.
     * @param ctx the parse tree
     */
    exitRelationalExpression?: (ctx: RelationalExpressionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.sumExpr`.
     * @param ctx the parse tree
     */
    enterSumExpr?: (ctx: SumExprContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.sumExpr`.
     * @param ctx the parse tree
     */
    exitSumExpr?: (ctx: SumExprContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.prodExpr`.
     * @param ctx the parse tree
     */
    enterProdExpr?: (ctx: ProdExprContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.prodExpr`.
     * @param ctx the parse tree
     */
    exitProdExpr?: (ctx: ProdExprContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.powExpr`.
     * @param ctx the parse tree
     */
    enterPowExpr?: (ctx: PowExprContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.powExpr`.
     * @param ctx the parse tree
     */
    exitPowExpr?: (ctx: PowExprContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.unaryExpression`.
     * @param ctx the parse tree
     */
    enterUnaryExpression?: (ctx: UnaryExpressionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.unaryExpression`.
     * @param ctx the parse tree
     */
    exitUnaryExpression?: (ctx: UnaryExpressionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.primaryExpression`.
     * @param ctx the parse tree
     */
    enterPrimaryExpression?: (ctx: PrimaryExpressionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.primaryExpression`.
     * @param ctx the parse tree
     */
    exitPrimaryExpression?: (ctx: PrimaryExpressionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.startNode`.
     * @param ctx the parse tree
     */
    enterStartNode?: (ctx: StartNodeContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.startNode`.
     * @param ctx the parse tree
     */
    exitStartNode?: (ctx: StartNodeContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.node`.
     * @param ctx the parse tree
     */
    enterNode?: (ctx: NodeContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.node`.
     * @param ctx the parse tree
     */
    exitNode?: (ctx: NodeContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.functionOrVar`.
     * @param ctx the parse tree
     */
    enterFunctionOrVar?: (ctx: FunctionOrVarContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.functionOrVar`.
     * @param ctx the parse tree
     */
    exitFunctionOrVar?: (ctx: FunctionOrVarContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.function`.
     * @param ctx the parse tree
     */
    enterFunction?: (ctx: FunctionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.function`.
     * @param ctx the parse tree
     */
    exitFunction?: (ctx: FunctionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.var`.
     * @param ctx the parse tree
     */
    enterVar?: (ctx: VarContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.var`.
     * @param ctx the parse tree
     */
    exitVar?: (ctx: VarContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.localFunctionOrVar`.
     * @param ctx the parse tree
     */
    enterLocalFunctionOrVar?: (ctx: LocalFunctionOrVarContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.localFunctionOrVar`.
     * @param ctx the parse tree
     */
    exitLocalFunctionOrVar?: (ctx: LocalFunctionOrVarContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.localFunction`.
     * @param ctx the parse tree
     */
    enterLocalFunction?: (ctx: LocalFunctionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.localFunction`.
     * @param ctx the parse tree
     */
    exitLocalFunction?: (ctx: LocalFunctionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.localVar`.
     * @param ctx the parse tree
     */
    enterLocalVar?: (ctx: LocalVarContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.localVar`.
     * @param ctx the parse tree
     */
    exitLocalVar?: (ctx: LocalVarContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.methodOrProperty`.
     * @param ctx the parse tree
     */
    enterMethodOrProperty?: (ctx: MethodOrPropertyContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.methodOrProperty`.
     * @param ctx the parse tree
     */
    exitMethodOrProperty?: (ctx: MethodOrPropertyContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.method`.
     * @param ctx the parse tree
     */
    enterMethod?: (ctx: MethodContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.method`.
     * @param ctx the parse tree
     */
    exitMethod?: (ctx: MethodContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.methodArgs`.
     * @param ctx the parse tree
     */
    enterMethodArgs?: (ctx: MethodArgsContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.methodArgs`.
     * @param ctx the parse tree
     */
    exitMethodArgs?: (ctx: MethodArgsContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.property`.
     * @param ctx the parse tree
     */
    enterProperty?: (ctx: PropertyContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.property`.
     * @param ctx the parse tree
     */
    exitProperty?: (ctx: PropertyContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.reference`.
     * @param ctx the parse tree
     */
    enterReference?: (ctx: ReferenceContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.reference`.
     * @param ctx the parse tree
     */
    exitReference?: (ctx: ReferenceContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.indexer`.
     * @param ctx the parse tree
     */
    enterIndexer?: (ctx: IndexerContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.indexer`.
     * @param ctx the parse tree
     */
    exitIndexer?: (ctx: IndexerContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.projection`.
     * @param ctx the parse tree
     */
    enterProjection?: (ctx: ProjectionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.projection`.
     * @param ctx the parse tree
     */
    exitProjection?: (ctx: ProjectionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.selection`.
     * @param ctx the parse tree
     */
    enterSelection?: (ctx: SelectionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.selection`.
     * @param ctx the parse tree
     */
    exitSelection?: (ctx: SelectionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.firstSelection`.
     * @param ctx the parse tree
     */
    enterFirstSelection?: (ctx: FirstSelectionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.firstSelection`.
     * @param ctx the parse tree
     */
    exitFirstSelection?: (ctx: FirstSelectionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.lastSelection`.
     * @param ctx the parse tree
     */
    enterLastSelection?: (ctx: LastSelectionContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.lastSelection`.
     * @param ctx the parse tree
     */
    exitLastSelection?: (ctx: LastSelectionContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.type`.
     * @param ctx the parse tree
     */
    enterType?: (ctx: TypeContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.type`.
     * @param ctx the parse tree
     */
    exitType?: (ctx: TypeContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.name`.
     * @param ctx the parse tree
     */
    enterName?: (ctx: NameContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.name`.
     * @param ctx the parse tree
     */
    exitName?: (ctx: NameContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.quotableName`.
     * @param ctx the parse tree
     */
    enterQuotableName?: (ctx: QuotableNameContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.quotableName`.
     * @param ctx the parse tree
     */
    exitQuotableName?: (ctx: QuotableNameContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.attribute`.
     * @param ctx the parse tree
     */
    enterAttribute?: (ctx: AttributeContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.attribute`.
     * @param ctx the parse tree
     */
    exitAttribute?: (ctx: AttributeContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.lambda`.
     * @param ctx the parse tree
     */
    enterLambda?: (ctx: LambdaContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.lambda`.
     * @param ctx the parse tree
     */
    exitLambda?: (ctx: LambdaContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.argList`.
     * @param ctx the parse tree
     */
    enterArgList?: (ctx: ArgListContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.argList`.
     * @param ctx the parse tree
     */
    exitArgList?: (ctx: ArgListContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.ctor`.
     * @param ctx the parse tree
     */
    enterCtor?: (ctx: CtorContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.ctor`.
     * @param ctx the parse tree
     */
    exitCtor?: (ctx: CtorContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.arrayConstructor`.
     * @param ctx the parse tree
     */
    enterArrayConstructor?: (ctx: ArrayConstructorContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.arrayConstructor`.
     * @param ctx the parse tree
     */
    exitArrayConstructor?: (ctx: ArrayConstructorContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.arrayRank`.
     * @param ctx the parse tree
     */
    enterArrayRank?: (ctx: ArrayRankContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.arrayRank`.
     * @param ctx the parse tree
     */
    exitArrayRank?: (ctx: ArrayRankContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.listInitializer`.
     * @param ctx the parse tree
     */
    enterListInitializer?: (ctx: ListInitializerContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.listInitializer`.
     * @param ctx the parse tree
     */
    exitListInitializer?: (ctx: ListInitializerContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.mapInitializer`.
     * @param ctx the parse tree
     */
    enterMapInitializer?: (ctx: MapInitializerContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.mapInitializer`.
     * @param ctx the parse tree
     */
    exitMapInitializer?: (ctx: MapInitializerContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.mapEntry`.
     * @param ctx the parse tree
     */
    enterMapEntry?: (ctx: MapEntryContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.mapEntry`.
     * @param ctx the parse tree
     */
    exitMapEntry?: (ctx: MapEntryContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.ctorArgs`.
     * @param ctx the parse tree
     */
    enterCtorArgs?: (ctx: CtorArgsContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.ctorArgs`.
     * @param ctx the parse tree
     */
    exitCtorArgs?: (ctx: CtorArgsContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.argument`.
     * @param ctx the parse tree
     */
    enterArgument?: (ctx: ArgumentContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.argument`.
     * @param ctx the parse tree
     */
    exitArgument?: (ctx: ArgumentContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.namedArgument`.
     * @param ctx the parse tree
     */
    enterNamedArgument?: (ctx: NamedArgumentContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.namedArgument`.
     * @param ctx the parse tree
     */
    exitNamedArgument?: (ctx: NamedArgumentContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.qualifiedId`.
     * @param ctx the parse tree
     */
    enterQualifiedId?: (ctx: QualifiedIdContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.qualifiedId`.
     * @param ctx the parse tree
     */
    exitQualifiedId?: (ctx: QualifiedIdContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.literal`.
     * @param ctx the parse tree
     */
    enterLiteral?: (ctx: LiteralContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.literal`.
     * @param ctx the parse tree
     */
    exitLiteral?: (ctx: LiteralContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.nullLiteral`.
     * @param ctx the parse tree
     */
    enterNullLiteral?: (ctx: NullLiteralContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.nullLiteral`.
     * @param ctx the parse tree
     */
    exitNullLiteral?: (ctx: NullLiteralContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.integerLiteral`.
     * @param ctx the parse tree
     */
    enterIntegerLiteral?: (ctx: IntegerLiteralContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.integerLiteral`.
     * @param ctx the parse tree
     */
    exitIntegerLiteral?: (ctx: IntegerLiteralContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.hexLiteral`.
     * @param ctx the parse tree
     */
    enterHexLiteral?: (ctx: HexLiteralContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.hexLiteral`.
     * @param ctx the parse tree
     */
    exitHexLiteral?: (ctx: HexLiteralContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.realLiteral`.
     * @param ctx the parse tree
     */
    enterRealLiteral?: (ctx: RealLiteralContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.realLiteral`.
     * @param ctx the parse tree
     */
    exitRealLiteral?: (ctx: RealLiteralContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.stringLiteral`.
     * @param ctx the parse tree
     */
    enterStringLiteral?: (ctx: StringLiteralContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.stringLiteral`.
     * @param ctx the parse tree
     */
    exitStringLiteral?: (ctx: StringLiteralContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.boolLiteral`.
     * @param ctx the parse tree
     */
    enterBoolLiteral?: (ctx: BoolLiteralContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.boolLiteral`.
     * @param ctx the parse tree
     */
    exitBoolLiteral?: (ctx: BoolLiteralContext) => void;
    /**
     * Enter a parse tree produced by `ExpressionParser.relationalOperator`.
     * @param ctx the parse tree
     */
    enterRelationalOperator?: (ctx: RelationalOperatorContext) => void;
    /**
     * Exit a parse tree produced by `ExpressionParser.relationalOperator`.
     * @param ctx the parse tree
     */
    exitRelationalOperator?: (ctx: RelationalOperatorContext) => void;
}
