import { ParseTreeVisitor } from "antlr4ts/tree/ParseTreeVisitor";
import { ExprContext } from "./ExpressionParser";
import { ExprListContext } from "./ExpressionParser";
import { ExpressionContext } from "./ExpressionParser";
import { ParenExprContext } from "./ExpressionParser";
import { LogicalOrExpressionContext } from "./ExpressionParser";
import { LogicalXorExpressionContext } from "./ExpressionParser";
import { LogicalAndExpressionContext } from "./ExpressionParser";
import { RelationalExpressionContext } from "./ExpressionParser";
import { SumExprContext } from "./ExpressionParser";
import { ProdExprContext } from "./ExpressionParser";
import { PowExprContext } from "./ExpressionParser";
import { UnaryExpressionContext } from "./ExpressionParser";
import { PrimaryExpressionContext } from "./ExpressionParser";
import { StartNodeContext } from "./ExpressionParser";
import { NodeContext } from "./ExpressionParser";
import { FunctionOrVarContext } from "./ExpressionParser";
import { FunctionContext } from "./ExpressionParser";
import { VarContext } from "./ExpressionParser";
import { LocalFunctionOrVarContext } from "./ExpressionParser";
import { LocalFunctionContext } from "./ExpressionParser";
import { LocalVarContext } from "./ExpressionParser";
import { MethodOrPropertyContext } from "./ExpressionParser";
import { MethodContext } from "./ExpressionParser";
import { MethodArgsContext } from "./ExpressionParser";
import { PropertyContext } from "./ExpressionParser";
import { ReferenceContext } from "./ExpressionParser";
import { IndexerContext } from "./ExpressionParser";
import { ProjectionContext } from "./ExpressionParser";
import { SelectionContext } from "./ExpressionParser";
import { FirstSelectionContext } from "./ExpressionParser";
import { LastSelectionContext } from "./ExpressionParser";
import { TypeContext } from "./ExpressionParser";
import { NameContext } from "./ExpressionParser";
import { QuotableNameContext } from "./ExpressionParser";
import { AttributeContext } from "./ExpressionParser";
import { LambdaContext } from "./ExpressionParser";
import { ArgListContext } from "./ExpressionParser";
import { CtorContext } from "./ExpressionParser";
import { ArrayConstructorContext } from "./ExpressionParser";
import { ArrayRankContext } from "./ExpressionParser";
import { ListInitializerContext } from "./ExpressionParser";
import { MapInitializerContext } from "./ExpressionParser";
import { MapEntryContext } from "./ExpressionParser";
import { CtorArgsContext } from "./ExpressionParser";
import { ArgumentContext } from "./ExpressionParser";
import { NamedArgumentContext } from "./ExpressionParser";
import { QualifiedIdContext } from "./ExpressionParser";
import { LiteralContext } from "./ExpressionParser";
import { NullLiteralContext } from "./ExpressionParser";
import { IntegerLiteralContext } from "./ExpressionParser";
import { HexLiteralContext } from "./ExpressionParser";
import { RealLiteralContext } from "./ExpressionParser";
import { StringLiteralContext } from "./ExpressionParser";
import { BoolLiteralContext } from "./ExpressionParser";
import { RelationalOperatorContext } from "./ExpressionParser";
/**
 * This interface defines a complete generic visitor for a parse tree produced
 * by `ExpressionParser`.
 *
 * @param <Result> The return type of the visit operation. Use `void` for
 * operations with no return type.
 */
export interface ExpressionVisitor<Result> extends ParseTreeVisitor<Result> {
    /**
     * Visit a parse tree produced by `ExpressionParser.expr`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitExpr?: (ctx: ExprContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.exprList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitExprList?: (ctx: ExprListContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.expression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitExpression?: (ctx: ExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.parenExpr`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitParenExpr?: (ctx: ParenExprContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.logicalOrExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLogicalOrExpression?: (ctx: LogicalOrExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.logicalXorExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLogicalXorExpression?: (ctx: LogicalXorExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.logicalAndExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLogicalAndExpression?: (ctx: LogicalAndExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.relationalExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitRelationalExpression?: (ctx: RelationalExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.sumExpr`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitSumExpr?: (ctx: SumExprContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.prodExpr`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitProdExpr?: (ctx: ProdExprContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.powExpr`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitPowExpr?: (ctx: PowExprContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.unaryExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitUnaryExpression?: (ctx: UnaryExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.primaryExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitPrimaryExpression?: (ctx: PrimaryExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.startNode`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStartNode?: (ctx: StartNodeContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.node`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitNode?: (ctx: NodeContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.functionOrVar`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunctionOrVar?: (ctx: FunctionOrVarContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.function`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunction?: (ctx: FunctionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.var`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitVar?: (ctx: VarContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.localFunctionOrVar`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLocalFunctionOrVar?: (ctx: LocalFunctionOrVarContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.localFunction`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLocalFunction?: (ctx: LocalFunctionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.localVar`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLocalVar?: (ctx: LocalVarContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.methodOrProperty`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMethodOrProperty?: (ctx: MethodOrPropertyContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.method`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMethod?: (ctx: MethodContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.methodArgs`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMethodArgs?: (ctx: MethodArgsContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.property`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitProperty?: (ctx: PropertyContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.reference`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitReference?: (ctx: ReferenceContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.indexer`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIndexer?: (ctx: IndexerContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.projection`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitProjection?: (ctx: ProjectionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.selection`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitSelection?: (ctx: SelectionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.firstSelection`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFirstSelection?: (ctx: FirstSelectionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.lastSelection`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLastSelection?: (ctx: LastSelectionContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.type`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitType?: (ctx: TypeContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.name`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitName?: (ctx: NameContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.quotableName`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitQuotableName?: (ctx: QuotableNameContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.attribute`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitAttribute?: (ctx: AttributeContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.lambda`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLambda?: (ctx: LambdaContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.argList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitArgList?: (ctx: ArgListContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.ctor`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitCtor?: (ctx: CtorContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.arrayConstructor`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitArrayConstructor?: (ctx: ArrayConstructorContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.arrayRank`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitArrayRank?: (ctx: ArrayRankContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.listInitializer`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitListInitializer?: (ctx: ListInitializerContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.mapInitializer`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMapInitializer?: (ctx: MapInitializerContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.mapEntry`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMapEntry?: (ctx: MapEntryContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.ctorArgs`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitCtorArgs?: (ctx: CtorArgsContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.argument`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitArgument?: (ctx: ArgumentContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.namedArgument`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitNamedArgument?: (ctx: NamedArgumentContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.qualifiedId`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitQualifiedId?: (ctx: QualifiedIdContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.literal`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLiteral?: (ctx: LiteralContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.nullLiteral`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitNullLiteral?: (ctx: NullLiteralContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.integerLiteral`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIntegerLiteral?: (ctx: IntegerLiteralContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.hexLiteral`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitHexLiteral?: (ctx: HexLiteralContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.realLiteral`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitRealLiteral?: (ctx: RealLiteralContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.stringLiteral`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStringLiteral?: (ctx: StringLiteralContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.boolLiteral`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitBoolLiteral?: (ctx: BoolLiteralContext) => Result;
    /**
     * Visit a parse tree produced by `ExpressionParser.relationalOperator`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitRelationalOperator?: (ctx: RelationalOperatorContext) => Result;
}
